# +++++++++++++++++++++++++++++++++++++++++++++++++++++++
# AB: maj en oct 2005
# ++++++++++++++++++++++++++++++++++++++++++++++++++++
# LES MTHODES 'poly'
# ++++++++++++++++++++++++++++++++++++++++++++++++++++

# -----------------------------------------------------
# as.poly: cr un objet 'poly'  partir:
# - soit de 2 vecteurs contenant respectivement les
# abcisses  et ordonnes d'un polygone
# - soit d'une matrice  2 colonnes, contenant respectivement les
# abcisses  et ordonnes 
# Arguments:
# - 2 vecteurs numriques de mme longueur
# - ou bien , une matrice numrique ayant au moins 2 colonnes:
# la 1ire colonne est suppose contenir les x,
# et la 2ime est suppose contenir les y.
# ----------------------------------------
# Remarque pour l'utilisateur:
# Pour crer une matrice de coordonnes
# en cliquant interactivement sur des points d'un graphique,
# utilisez 'getpoly' de splancs, puis utilisez cette fonction
# pour le convertir en objet 'poly'
# -----------------------------------------------------
as.poly <- function(x, ...) {
  nbargs <- nargs()
  if ( (nbargs !=2) &&  (nbargs !=1)) {
    stop("The number of arguments is wrong: should be a vector x and a vector y\
 or else a two-columns matrix.") 
  }
  if (nbargs == 1) {
# Une matrice
    if (ncol(x) < 2)
      stop("Argument should be a matrix with at least two columns.")
    retour <- matrix(c(x[,1], x[,2]), ncol=2)
  }

  else {
# Un vecteur de x et un de y
    argu2 <- eval(match.call()[[3]])
    if (length(x) != length(argu2)) 
      stop("The x-vector and the y-vector have not the same length.")
    retour <- matrix(c(x, argu2), ncol=2)
  }

  if (nrow(retour) <3) 
    warning("The polygon has less than three points.")

  dimnames(retour) <- list(NULL, c("xcoord", "ycoord"))
  class(retour) <- "poly"
  return(retour)
}



# -----------------------------------------------------
# plot.poly: Plot d'un objet 'poly'  l'aide de la fonction 'polymap'
# de splancs
# Si le poly a un attribut 'couleur', il est trac dans cette couleur
# Arguments:
# - un objet de classe 'poly'
# - une liste variable d'arguments qui seront passs tels quels
#   'polymap'
# -----------------------------------------------------
plot.poly <- function(x, ...) {
# On 'dclasse' l'objet car polymap appelle 'plot'
# sur l'objet et a appelerait automatiquement 'plot.poly'  la place
# du plot standard.
  poly <- unclass(x)

# On charge 'splancs' si non dj fait:
  if (!any(search() == "package:splancs"))
    library(splancs)

  if (!is.null(attr(poly, "couleur")))
    polymap(poly, col=attr(poly, "couleur"), ...)
  else
    polymap(poly, ...)
}
# -----------------------------------------------------
