\name{gpe}
\alias{gpe}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{ Create groups of values from a result-file }
\description{
  Create groups from values read on a result-file.
  Optionally, plot the polygons colored according to the group
  they are classed into.
}
\usage{
gpe(fileres, logr = FALSE, n.gp = 3, meth = "", igr = c(3, 4), datafile = NULL, format = 1, delim = " ", plotfile = "gp", ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{fileres}{ Pathname of a result-file }
  \item{logr}{ When TRUE, groups are created from the log of the results.}
  \item{n.gp}{ Maximal number of groups }
  \item{meth}{ When equal to "pam", groups are created by the function "pam" of the
    package 'cluster'.
    Otherwise, \code{n.gp} groups of equal length are created.
    }
  \item{igr}{ Index, on the result-file, of the values to be grouped.}
  \item{datafile}{ If non NULL, should be the polygons-file
    from which the results have been calculated.
    Then, plots of the polygons, colored according to their group
    are done.
    The following arguments are taken into account if \code{datafile} is
    set, only.}
  \item{format}{ Format of the polygons-file; should be 1 or 2}
  \item{delim}{ Separator character on the polygons-file }
  \item{plotfile}{  Prefix of the PostScript files. If NULL, plots are on X11.}
  \item{\dots}{ Arguments to be passed to the function 'plot'}
}
\value{
A list with components:
  \item{match.call }{the creation command }
  \item{for_each_value_i_of_igr }{a list with the component \code{res}:
    a matrix, the row-labels of which are the polygons identifiers,
    and the two-colums are the sum of the results and the groups.
    In addition, when the method is 'pam', the return value of
    the function 'pam' and otherwise, \code{scale}, the extend of each
    group.}
}
\author{ MIA-Jouy }
\keyword{utilities}
